﻿' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

Imports Windows.UI.Core
Imports System.Runtime.CompilerServices
Imports C1.Xaml
''' <summary>
''' An empty page that can be used on its own or navigated to within a Frame.
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page
    Private data As New List(Of Integer)() From {
        0,
        15,
        30,
        45,
        60
    }
    Private count As Int16 = 0

    Public Sub New()
        Me.InitializeComponent()
        AddHandler Loaded, AddressOf MainPage_Loaded
    End Sub

    Private Async Sub MainPage_Loaded(sender As Object, e As RoutedEventArgs)
        Await Dispatcher.RunAsync(CoreDispatcherPriority.Normal, Function()
                                                                     Dim minute = FindChild(Of ComboBox)(dts, "MinutesList")
                                                                     If minute IsNot Nothing Then
                                                                         minute.ItemsSource = data
                                                                         minute.ItemTemplate = Nothing
                                                                         minute.SelectedIndex = 0
                                                                     End If
                                                                     Return 0
                                                                 End Function)

    End Sub
    ''' <summary>
    ''' Finds a Child of a given item in the visual tree. 
    ''' </summary>
    ''' <param name="parent">A direct parent of the queried item.</param>
    ''' <typeparam name="T">The type of the queried item.</typeparam>
    ''' <param name="childName">x:Name or Name of child. </param>
    ''' <returns>The first parent item that matches the submitted type parameter. 
    ''' If not matching item can be found, 
    ''' a null parent is being returned.</returns>
    Public Function FindChild(Of T As DependencyObject)(parent As DependencyObject, childName As String) As T
        ' Confirm parent and childName are valid. 
        If parent Is Nothing Then
            Return Nothing
        End If

        Dim foundChild As T = Nothing

        Dim childrenCount As Integer = VisualTreeHelper.GetChildrenCount(parent)
        For i As Integer = 0 To childrenCount - 1
            Dim child = VisualTreeHelper.GetChild(parent, i)
            ' If the child is not of the request child type child
            Dim childType As T = TryCast(child, T)
            If childType Is Nothing Then
                ' recursively drill down the tree
                foundChild = FindChild(Of T)(child, childName)

                ' If the child is found, break so we do not overwrite the found child. 
                If foundChild IsNot Nothing Then
                    Exit For
                End If
            ElseIf Not String.IsNullOrEmpty(childName) Then
                Dim frameworkElement = TryCast(child, FrameworkElement)
                ' If the child's name is set for search
                If frameworkElement IsNot Nothing AndAlso frameworkElement.Name = childName Then
                    ' if the child's name is of the request name
                    foundChild = DirectCast(child, T)
                    Exit For
                End If
            Else
                ' child element found.
                foundChild = DirectCast(child, T)
                Exit For
            End If
        Next

        Return foundChild
    End Function

    Public Sub UpdateItemsSource(dts As C1DateTimeSelector)
        Dim minute = FindChild(Of ComboBox)(dts, "MinutesList")
        If minute IsNot Nothing Then
            If minute.Tag Is Nothing And count < 3 Then
                minute.ItemsSource = data
                minute.ItemTemplate = Nothing
                minute.SelectedIndex = 0
                count = count + 1
                If (count = 3) Then
                    minute.Tag = True
                    count = 0
                End If
            End If
            End If
    End Sub

    Private Sub C1TabItem_LayoutUpdated(sender As Object, e As Object)
        UpdateItemsSource(dts1)
    End Sub

    Private Sub C1TabItem_LayoutUpdated_1(sender As Object, e As Object)
        UpdateItemsSource(dts2)
    End Sub
End Class